PPATH - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on...

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

    1033
    1733     
    3733     
    3739     
    3779
    8779
    8179     
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Example

Input:
3
1033 8179
1373 8017
1033 1033

Output:
6
7
0

hide comments
dennislo: 2018-06-29 03:27:40

Good problem

nitish235: 2018-06-16 11:34:41

took 2 hrs to think this as bfs then got AC 0.15

aman9598: 2018-06-08 21:09:37

wrong testcases
1033 8179
correct output is 7

atharva_sarage: 2018-06-07 12:53:48

AC in first shot
must do bfs problem

flyingduchman_: 2018-05-12 19:57:17

BFS tag ... What is the graph ?
It's the puzzle, try to figure it out.
.
.
.
For attitude :I am a programmer, not a puzzle solver ,The graph is
conceptual and you can't see all vertices & edges as a first snapshot like many other problems.But the graph is describeable in gradual order. As first snapshot : you know the source vertex and it's neighbour vertices, destination vertex. Each vertex's
neighbour verties are = all prime number from the Set {All numbers i.e. each one is a permutation of source number with only one digit difference} . Cost of each edge = 1.
So, neighbour vertices of 1033 is = Prime numbers among( 1033...9033, 1133..1933, 1003...1093, 1030....1039) , for clearity (1_ _ _ ... 9 _ _ _, _0_ _ ... _9_ _, _ _ 0 _..._ _ 9_, _ _ _ 0... _ _ _ 9), '_' remain unchanged in the permutation.

Task : Find shortest path between source and destination vertex, if no path exists print "Impossible".

Last edit: 2018-05-12 19:59:56
maruf_robin: 2018-05-03 19:02:58

Excellent Question. Fun to solve. I faced problem to add the edges but got AC in one go after hours.

thanos_tapras: 2018-04-22 13:16:10

Really nice problem! Great problem for BFS with good balance between concept difficulty and implementation difficulty.

addynation: 2018-03-15 00:19:03

AC in one go!

himansh242: 2018-01-31 08:24:56

AC in a go 0.01 ;)

ameyanator: 2017-12-24 07:08:50

AC in one go!! yayy GREaat problem <3


Added by:overwise
Date:2007-10-02
Time limit:2s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO NODEJS PERL6 VB.NET
Resource:ACM ICPC NWERC 2006